from collections import deque, defaultdict
def find_guarded_warehouses(p, t, roads, k, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded_warehouses = set()
    for warehouse_id, endurance in guards:
        queue = deque([(warehouse_id, 0)])
        visited = set()
        visited.add(warehouse_id)

        while queue:
            current_warehouse, distance = queue.popleft()
            if distance > endurance:
                continue
            guarded_warehouses.add(current_warehouse)
            for neighbor in graph[current_warehouse]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))
    return sorted(guarded_warehouses)
p = 5
t = 4
roads = [(1, 2), (1, 3), (2, 4), (3, 5)]
k = 2
guards = [(1, 2), (3, 1)]
guarded_warehouses = find_guarded_warehouses(p, t, roads, k, guards)
print(guarded_warehouses)
